package bookExamples.ch26Graphics.draw2d.shapes;


import j2d.ImageUtils;

import java.awt.*;

public class ImageShape extends DJShape {
    int x1 = 0;
    int y1 = 0;
    int x2 = 0;
    int y2 = 0;
    private Image image;

    public ImageShape(int x1, int y1, int x2, int y2, Image img) {
        super(x1, y1, x2, y2);
        image = img;
        initImage(x1, y1, x2, y2);
    }

    private void initImage(int x1, int y1, int x2, int y2) {
        this.x1 = x1;
        this.y1 = y1;
        this.x2 = x2;
        this.y2 = y2;
        if (image==null) return;
        ImageUtils.waitForImage(image);
        setSize(image.getWidth(null), image.getHeight(null));
    }

    public ImageShape(int x1, int y1, int x2, int y2) {
        super(x1, y1, x2, y2);
        image = ImageUtils.getImage();
        initImage(x1, y1, x2, y2);
    }

    private void setSize(int width, int height) {
        setSize(new Dimension(width, height));
    }

    public void draw(Graphics g) {

        Graphics2D g2d = (Graphics2D) g;

        g2d.drawImage(image, 0, 0, null);
        /*
        AffineTransform affineTransform = getAffineTransform();
        if (image == null) return;

        affineTransform.setToTranslation(x1, y1);

        g2d.drawImage(image,
                affineTransform, null);
                */

    }

    public Point getCenter() {
        Dimension d = getSize();
        return new Point(x1 + d.width / 2, y2 + d.height / 2);
    }

    Point pc = new Point(x1, y1);

    public DJShape getInstance(int x1, int y1, int x2, int y2) {
        return this;
    }

    public Image getImage() {
        return image;
    }
}